package com.uoc.chapi.Commons;

import android.annotation.TargetApi;
import android.content.Context;
import android.os.Build;
import android.os.Environment;
import android.util.Log;

import com.uoc.chapi.GPX.GpxPoint;

import java.io.File;
import java.io.FileWriter;
import java.text.SimpleDateFormat;
import java.util.ArrayList;

import static com.uoc.chapi.InitialActivity.DIR_ROUTES;

/**
 * Created by Chapi on 26/04/2017.
 */

public class Commons  {

    static public int NUM_MAX_POINTS = 100;

    public static final SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ssZ");

    static public String saveGPXFile (Context context, String nameFile, ArrayList<GpxPoint> points) {

        String nameFileSaved = null;

        if (points != null) {
            FileWriter fileWriter = null;
            try {
                File fileDir = getFileDir(context);

                if (fileDir != null) {

                    nameFileSaved = fileDir + "/" + nameFile;
                    fileWriter = new FileWriter(nameFileSaved);

                    fileWriter.write("<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\" ?>\n");
                    fileWriter.write("<gpx xmlns=\"http://www.topografix.com/GPX/1/1\" creator=\"byHand\" version=\"1.1\"\n");
                    fileWriter.write("xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n");
                    fileWriter.write("xsi:schemaLocation=\"http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd\">\n");
                    fileWriter.write("\t<trk>\n");
                    fileWriter.write("\t\t<trkseg>\n");



                    for (GpxPoint point : points) {
                        fileWriter.write("\t\t\t<trkpt lat=\"" + point.GetLatitude()
                                + "\" lon=\"" + point.GetLongitude() + "\">\n");
                        fileWriter.write("\t\t\t\t<ele>" + point.GetElevation() + "</ele>\n");
                        fileWriter.write("\t\t\t\t<time>" + simpleDateFormat.format(point.GetDate()) + "</time>\n");
                        fileWriter.write("\t\t\t</trkpt>\n");
                    }

                    fileWriter.write("\t\t</trkseg>\n");
                    fileWriter.write("\t</trk>\n");
                    fileWriter.write("</gpx>\n");

                    fileWriter.close();
                }
            } catch (Exception e) {
                Log.d("TFM", e.toString());
            }
        }

        return nameFileSaved;
    }

    static public File getFileDir(Context context) {

        File fileDir = null;

        //Comprobamos el estado de la memoria externa (tarjeta SD)
        String estado = Environment.getExternalStorageState();
        if (estado.equals(Environment.MEDIA_MOUNTED)) {
            if (getStateAndroidCC(context) == false) {
                fileDir = new File(Environment.getExternalStorageDirectory().getPath() + DIR_ROUTES);
            }
            else {
                File[] fileDirs = context.getExternalFilesDirs(null);

                if (fileDirs != null) {
                    for (int index = 0; index < fileDirs.length; index++) {
                        fileDir = new File(fileDirs[index].getParent() + "/TFM_Route");

                        if (!fileDir.toString().contains("emulate")) {

                            try {
                                if (!fileDir.exists()) {
                                    fileDir.mkdirs();
                                }
                            } catch (Exception e) {
                                Log.d("TFM", "Creating dir error : " + e.toString());
                            }

                            break;
                        }

                    }
                }
            }
        }

        return fileDir;
    }

    @TargetApi(Build.VERSION_CODES.KITKAT)
    public static Boolean getStateAndroidCC(Context context)
    {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {
            return true;
        }
        else {
            return false;
        }
    }
}
