package com.uoc.chapi.FollowRoute;

import android.content.DialogInterface;
import android.content.Intent;
import android.support.v7.app.AlertDialog;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.MenuInflater;
import android.view.MenuItem;


import android.os.Bundle;
import android.support.design.widget.TabLayout;
import android.support.v4.view.ViewPager;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.widget.Toast;

import com.uoc.chapi.NewRoute.NewRouteMap;
import com.uoc.chapi.Commons.NameRoute;
import com.uoc.chapi.Routes.R;

import java.io.File;


public class RouteToFollow extends AppCompatActivity {

    private  String TAG = "TFM-RouteToFollow";

    public static final String ARG_NAME_ROUTE = "Ruta Unknown";

    public static String nameFile;

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0) {

            if (RouteToFollowMap.IsRunning()) {
                Toast toast = Toast.makeText(getApplicationContext(), R.string.routeRunningDelete, Toast.LENGTH_LONG);
                toast.setGravity(Gravity.CENTER, 0, 0);
                toast.show();
                return true;
            }
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.route_to_follow);

        Log.d(TAG, "onCreate");

        RouteToFollowProfile.SetWithinRoute(false);

        Toolbar toolbar = (Toolbar) findViewById(R.id.routeToFollowToolbar);
        toolbar.setTitle(getIntent().getStringExtra(RouteToFollow.ARG_NAME_ROUTE));
        setSupportActionBar(toolbar);

        TabLayout tabLayout = (TabLayout) findViewById(R.id.routetoFollowTabLayout);
        tabLayout.addTab(tabLayout.newTab().setText("Perfil"));
        tabLayout.addTab(tabLayout.newTab().setText(R.string.mapa_route));
        tabLayout.addTab(tabLayout.newTab().setText("Detalle"));
        tabLayout.setTabGravity(TabLayout.GRAVITY_FILL);

        final ViewPager viewPager = (ViewPager) findViewById(R.id.routeToFollowViewPager);
        final RouteToFollowPagerAdapter adapter = new RouteToFollowPagerAdapter
                (getSupportFragmentManager(), tabLayout.getTabCount());
        viewPager.setAdapter(adapter);
        viewPager.setOffscreenPageLimit(2);
        viewPager.setCurrentItem(1);
        viewPager.addOnPageChangeListener(new TabLayout.TabLayoutOnPageChangeListener(tabLayout));
        tabLayout.setOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                viewPager.setCurrentItem(tab.getPosition());
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {

            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu_follow_map, menu);
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        switch (item.getItemId()) {
            case R.id.menuFollowMapShare:

                Log.d(TAG, "WhatsApp");

                try {
                    String uri = "http://maps.google.com/maps?q=loc:"
                            + NewRouteMap.getCurrentPositionLatitud()
                            + "," + NewRouteMap.getCurrentPositionLongitude();

                    Intent sendIntentWhatsApp = new Intent();
                    sendIntentWhatsApp.setAction(Intent.ACTION_SEND);
                    sendIntentWhatsApp.putExtra(android.content.Intent.EXTRA_TEXT, uri);
                    sendIntentWhatsApp.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);
                    sendIntentWhatsApp.setType("text/plain");
                    sendIntentWhatsApp.setPackage("com.whatsapp");
                    if (sendIntentWhatsApp != null) {
                        startActivity(sendIntentWhatsApp);
                    }
                }
                catch (Exception e) {
                    Log.d(TAG, "WhatsApp no instalado : " + e.getMessage());
                }

                return true;

            case R.id.menuFollowMapDelete:

                if (RouteToFollowMap.IsRunning()) {
                    Toast toast = Toast.makeText(getApplicationContext(), R.string.routeRunning, Toast.LENGTH_LONG);
                    toast.setGravity(Gravity.CENTER, 0, 0);
                    toast.show();
                    return true;
                } else {
                    AlertDialog.Builder showMenu = new AlertDialog.Builder(this);
                    showMenu.setMessage(R.string.wantedDeleteRoute);
                    showMenu.setCancelable(false);
                    showMenu.setPositiveButton(R.string.yes, new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialogo1, int id) {
                            try {
                                File file = new File(NameRoute.GetNameRouteFull());

                                if (file.exists()) {
                                    file.delete();
                                }
                            } catch (Exception e) {
                                Log.d(TAG, e.getMessage());
                            }

                            finish();
                        }
                    });
                    showMenu.setNegativeButton(R.string.no, new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialogo1, int id) {
                        }
                    });
                    showMenu.show();
                }

                return true;

            case R.id.menuFollowMapDownLoad:

                Toast toast = Toast.makeText(getApplicationContext(), R.string.doesNotWork, Toast.LENGTH_LONG);
                toast.setGravity(Gravity.CENTER, 0, 0);
                toast.show();

                return true;

            default:
                return super.onOptionsItemSelected(item);
        }
    }
}