package com.uoc.chapi.NewRoute;

import android.content.Intent;
import android.os.Bundle;
import android.support.design.widget.TabLayout;
import android.support.v4.view.ViewPager;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.Toast;

import com.uoc.chapi.Routes.R;

/**
 * Created by Chapi on 28/02/2017.
 */

public class NewRoute extends AppCompatActivity {

    private String TAG = "TFM-NewRoute";

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0) {

            if (NewRouteMap.IsRunning()) {
                Toast toast = Toast.makeText(getApplicationContext(), R.string.routeRunning, Toast.LENGTH_LONG);
                toast.setGravity(Gravity.CENTER, 0, 0);
                toast.show();
                return true;
            }
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.new_route);

        Log.d(TAG, "onCreate");

        Toolbar toolbar = (Toolbar) findViewById(R.id.newRouteToolbar);
        toolbar.setTitle(getIntent().getStringExtra("Nueva Ruta"));
        setSupportActionBar(toolbar);

        TabLayout tabLayout = (TabLayout) findViewById(R.id.newRouteTabLayout);
        tabLayout.addTab(tabLayout.newTab().setText("Perfil"));
        tabLayout.addTab(tabLayout.newTab().setText(R.string.mapa_route));
        tabLayout.addTab(tabLayout.newTab().setText("Detalle"));
        tabLayout.setTabGravity(TabLayout.GRAVITY_FILL);

        final ViewPager viewPager = (ViewPager) findViewById(R.id.newRouteViewPager);
        final NewRoutePageAdapter adapter = new NewRoutePageAdapter
                (getSupportFragmentManager(), tabLayout.getTabCount());
        viewPager.setAdapter(adapter);
        viewPager.setOffscreenPageLimit(2);
        viewPager.setCurrentItem(1);
        viewPager.addOnPageChangeListener(new TabLayout.TabLayoutOnPageChangeListener(tabLayout));
        tabLayout.setOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                viewPager.setCurrentItem(tab.getPosition());
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {

            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu_new_route, menu);
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.menuNewRouteshare:

                Log.d(TAG, "WhatsApp");

                try {
                    String uri = "http://maps.google.com/maps?q=loc:"
                            + NewRouteMap.getCurrentPositionLatitud()
                            + "," + NewRouteMap.getCurrentPositionLongitude();

                    Intent sendIntentWhatsApp = new Intent();
                    sendIntentWhatsApp.setAction(Intent.ACTION_SEND);
                    sendIntentWhatsApp.putExtra(android.content.Intent.EXTRA_TEXT, uri);
                    sendIntentWhatsApp.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);
                    sendIntentWhatsApp.setType("text/plain");
                    sendIntentWhatsApp.setPackage("com.whatsapp");
                    startActivity(sendIntentWhatsApp);
                }
                catch (Exception e) {
                    Log.d(TAG, "WhatsApp no instalado : " + e.getMessage());
                }


                return true;

            case R.id.menuNewRouteDownloadMap:

                Toast toast = Toast.makeText(getApplicationContext(), R.string.doesNotWork, Toast.LENGTH_LONG);
                toast.setGravity(Gravity.CENTER, 0, 0);
                toast.show();

            default:
                return super.onOptionsItemSelected(item);
        }
    }
}

