package com.uoc.chapi.NewRoute;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.uoc.chapi.Commons.Cronometro;
import com.uoc.chapi.Routes.R;

/**
 * Created by Chapi on 28/02/2017.
 */

public class NewRouteData extends Fragment {

    private String TAG = "TFM-NewRouteData";

    private ViewGroup viewGroup;

    static private Cronometro cronometro = null;
    static private TextView textViewCronometro;
    static private TextView newRouteDataRange;
    static private TextView newRouteDataAltitude;
    static private TextView newRouteDataMaxAltitude;
    static private TextView newRouteDataMinAltitude;
    static private TextView newRouteDataSteepPos;
    static private TextView newRouteDataSteepNeg;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {

        Log.d(TAG, "onCreateView");

        viewGroup = (ViewGroup) inflater.inflate(R.layout.new_route_data, container, false);

        textViewCronometro = (TextView) viewGroup.findViewById(R.id.newRouteDataCronometro);
        newRouteDataRange = (TextView) viewGroup.findViewById(R.id.newRouteDataRange);
        newRouteDataAltitude = (TextView) viewGroup.findViewById(R.id.newRouteDataAltitude);
        newRouteDataMaxAltitude = (TextView) viewGroup.findViewById(R.id.newRouteDataMaxAltitude);
        newRouteDataMinAltitude = (TextView) viewGroup.findViewById(R.id.newRouteDataMinAltitude);
        newRouteDataSteepPos = (TextView) viewGroup.findViewById(R.id.newRouteDataSteepPos);
        newRouteDataSteepNeg = (TextView) viewGroup.findViewById(R.id.newRouteDataSteepNeg);

        // Initialize values
        InitializeValues();

        cronometro = new Cronometro("Cronometro", textViewCronometro);

        new Thread(cronometro).start();

        return viewGroup;
    }

    @Override
    public void setMenuVisibility(final boolean visible) {
        super.setMenuVisibility(visible);
        Log.d(TAG, "setMenuVisibility");
    }

    /**
     *
     */
    private static void InitializeValues() {
        textViewCronometro.setText("00:00:00");
        newRouteDataRange.setText("00.000 Km");
        newRouteDataAltitude.setText("0 mt");
        newRouteDataMaxAltitude.setText("Max 0 mt");
        newRouteDataMinAltitude.setText("Min 0 mt");
        newRouteDataSteepPos.setText("D+ 0 mt");
        newRouteDataSteepNeg.setText("D- 0 mt");
    }

    /**
     *
     * @param range
     * @param altitude
     * @param maxAltitude
     * @param minAltitude
     * @param steepPos
     * @param steepNeg
     */
    static public void setData(double range
            , double altitude
            , double maxAltitude
            , double minAltitude
            , double steepPos
            , double steepNeg) {

        if (range < 1) {
            newRouteDataRange.setText(String.format("%.0f Mt", range * 1000));

        } else {
            newRouteDataRange.setText(String.format("%.2f Km", range));
        }

        newRouteDataAltitude.setText(String.format("%.0f Mt", altitude));

        newRouteDataMaxAltitude.setText(String.format("%.0f Mt", maxAltitude));
        newRouteDataMinAltitude.setText(String.format("%.0f Mt", minAltitude));

        newRouteDataSteepPos.setText(String.format("D+ %.0f Mt", steepPos));
        newRouteDataSteepNeg.setText(String.format("D- %.0f Mt", steepNeg));
    }

    static public void startCronometro() {

        InitializeValues();
        cronometro.start();
    }

    static void stopCronometro() {

        cronometro.reset();
    }

    static void pauseCronometro() {

        cronometro.pause();
    }
}

