package com.uoc.chapi.NewRoute;

import android.location.Location;
import android.location.LocationListener;
import android.os.Bundle;
import android.util.Log;

/**
 * Created by Chapi on 28/02/2017.
 */

public class NewRouteListener implements LocationListener {

    private  String TAG = "TFM-NewRouteListener";

    NewRouteMap newRouteMap;

    public NewRouteMap getNewRouteMap() {
        return newRouteMap;
    }

    public void setNewRouteMap(NewRouteMap newRouteMap) {
        this.newRouteMap = newRouteMap;
    }

    @Override
    public void onLocationChanged(Location loc) {

        // Este metodo se ejecuta cada vez que el GPS recibe nuevas coordenadas
        // debido a la detección de un cambio de ubicacion
        loc.getLatitude();
        loc.getLongitude();
        newRouteMap.setCurrentLocation(loc.getLatitude(), loc.getLongitude(), loc.getAltitude());
    }

    @Override
    public void onProviderDisabled(String provider) {
        // Este metodo se ejecuta cuando el GPS es desactivado
        Log.d(TAG, "GPS Desactivado");
    }

    @Override
    public void onProviderEnabled(String provider) {
        // Este metodo se ejecuta cuando el GPS es activado
        Log.d(TAG, "GPS Activado");
    }

    @Override
    public void onStatusChanged(String provider, int status, Bundle extras) {
        // Este metodo se ejecuta cada vez que se detecta un cambio en el
        // status del proveedor de localización (GPS)
        // Los diferentes Status son:
        // OUT_OF_SERVICE -> Si el proveedor esta fuera de servicio
        // TEMPORARILY_UNAVAILABLE -> Temporalmente no disponible pero se
        // espera que este disponible en breve
        // AVAILABLE -> Disponible
    }
}
