package com.uoc.chapi.NewRoute;

import android.graphics.Color;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.jjoe64.graphview.DefaultLabelFormatter;
import com.jjoe64.graphview.GraphView;
import com.jjoe64.graphview.LegendRenderer;
import com.jjoe64.graphview.series.DataPoint;
import com.jjoe64.graphview.series.LineGraphSeries;
import com.uoc.chapi.Routes.R;

import java.util.ArrayList;

/**
 * Created by Chapi on 28/02/2017.
 */

public class NewRouteProfile extends Fragment {

    private static String TAG = "TFM-NewRouteProfile";

    private static GraphView graph = null;

    private final int NUM_MAX_POINTS = 100;

    boolean hasCreatedTheActivity = false;

    static ArrayList<PointProfile> points;

    static double minAltura;
    static double maxAltura;
    static double range;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {

        Log.d(TAG, "onCreateView");

        ViewGroup viewGroup = (ViewGroup) inflater.inflate(R.layout.new_route_profile, container, false);

        points = new ArrayList<>();
        range = 0;
        minAltura = 0.0;
        maxAltura = 0.0;

        if (graph == null) {
            graph = (GraphView) viewGroup.findViewById(R.id.newRouteGraph);
        }

        graph.getGridLabelRenderer().setLabelFormatter(new DefaultLabelFormatter() {
            @Override
            public String formatLabel(double value, boolean isValueX) {
                if (!isValueX) {
                    // show normal x values
                    return super.formatLabel(value, isValueX) + "m";
                } else {
                    // show currency for y values
                    return super.formatLabel(value, isValueX);
                }
            }
        });

        hasCreatedTheActivity = true;

        return viewGroup;
    }

    static public void ClearRoute() {
        for (PointProfile point : points) {
            points.remove(point);
        }
    }


    static public void SetDetailRoute(double aRange, double altitude) {

        if (minAltura >= altitude) {
            minAltura = altitude;
        }

        if (maxAltura <= altitude) {
            maxAltura = altitude;
        }

        range = aRange;

        points.add(new PointProfile(range, altitude));
    }

    @Override
    public void setMenuVisibility(final boolean visible) {
        super.setMenuVisibility(visible);
        Log.d(TAG, "setMenuVisibility");

        if (points != null && points.size() > 0) {

            LineGraphSeries<DataPoint> series = new LineGraphSeries<DataPoint>();
            series.setColor(Color.argb(100, 0, 0, 127));
            series.setTitle("Km");
            series.setBackgroundColor(Color.argb(25, 0, 0, 127));
            series.setDrawBackground(true);

            int numPointsToDraw;
            int offsetPoints;
            if (points.size() > NUM_MAX_POINTS) {
                offsetPoints = points.size() / NUM_MAX_POINTS;
            }
            else {
                offsetPoints = 1;
            }

            numPointsToDraw = points.size() / offsetPoints;

            for (PointProfile point : points) {
                series.appendData(new DataPoint(point.range, point.altitude), true, numPointsToDraw);
            }

            graph.getViewport().setMinX(0);
            graph.getViewport().setMaxX(range);
            graph.getViewport().setMinY(minAltura);
            graph.getViewport().setMaxY(maxAltura);
            graph.getViewport().setXAxisBoundsManual(true);
            graph.getViewport().setYAxisBoundsManual(true);

            // enable scaling and scrolling
            graph.getViewport().setScalableY(true);

            graph.getLegendRenderer().setVisible(true);
            graph.getLegendRenderer().setAlign(LegendRenderer.LegendAlign.BOTTOM);

            graph.removeAllSeries();

            graph.addSeries(series);
        }
    }

    static class PointProfile {

        PointProfile(double range, double altitude) {
            this.altitude = altitude;
            this.range = range;
        }

        double altitude;
        double range;
    }
}


